SAFER::Enc Class Referenceabstract
Inheritance diagram for SAFER::Enc:

## Public Types

enum | IV_Requirement { UNIQUE_IV = 0, RANDOM_IV, UNPREDICTABLE_RANDOM_IV, INTERNALLY_GENERATED_IV, NOT_RESYNCHRONIZABLE }
enum | { BT_InBlockIsCounter =1, BT_DontIncrementInOutPointers =2, BT_XorInput =4, BT_ReverseDirection =8, BT_AllowParallel =16 }

## Public Member Functions

void | ProcessAndXorBlock (const byte *inBlock, const byte *xorBlock, byte *outBlock) const
| encrypt or decrypt inBlock, xor with xorBlock, and write to outBlock
unsigned int | OptimalDataAlignment () const
| returns how inputs and outputs should be aligned for optimal performance
void | UncheckedSetKey (const byte *userkey, unsigned int length, const NameValuePairs &params)
virtual size_t | MinKeyLength () const =0
| returns smallest valid key length in bytes */
virtual size_t | MaxKeyLength () const =0
| returns largest valid key length in bytes */
virtual size_t | DefaultKeyLength () const =0
| returns default (recommended) key length in bytes */
virtual size_t | GetValidKeyLength (size_t n) const =0
| returns the smallest valid key length in bytes that is >= min(n, GetMaxKeyLength())
virtual bool | IsValidKeyLength (size_t n) const
| returns whether n is a valid key length
virtual void | SetKey (const byte *key, size_t length, const NameValuePairs &params=g_nullNameValuePairs)
| set or reset the key of this object More...
void | SetKeyWithRounds (const byte *key, size_t length, int rounds)
| calls SetKey() with an NameValuePairs object that just specifies "Rounds"
void | SetKeyWithIV (const byte *key, size_t length, const byte *iv, size_t ivLength)
| calls SetKey() with an NameValuePairs object that just specifies "IV"
void | SetKeyWithIV (const byte *key, size_t length, const byte *iv)
| calls SetKey() with an NameValuePairs object that just specifies "IV"
virtual IV_Requirement | IVRequirement () const =0
| returns the minimal requirement for secure IVs
bool | IsResynchronizable () const
| returns whether this object can be resynchronized (i.e. supports initialization vectors) More...
bool | CanUseRandomIVs () const
| returns whether this object can use random IVs (in addition to ones returned by GetNextIV)
bool | CanUsePredictableIVs () const
| returns whether this object can use random but possibly predictable IVs (in addition to ones returned by GetNextIV)
bool | CanUseStructuredIVs () const
| returns whether this object can use structured IVs, for example a counter (in addition to ones returned by GetNextIV)
virtual unsigned int | IVSize () const
unsigned int | DefaultIVLength () const
| returns default length of IVs accepted by this object
virtual unsigned int | MinIVLength () const
| returns minimal length of IVs accepted by this object
virtual unsigned int | MaxIVLength () const
| returns maximal length of IVs accepted by this object
virtual void | Resynchronize (const byte *iv, int ivLength=-1)
| resynchronize with an IV. ivLength=-1 means use IVSize()
virtual void | GetNextIV (RandomNumberGenerator &rng, byte *IV)
| get a secure IV for the next message More...
void | ProcessBlock (const byte *inBlock, byte *outBlock) const
| encrypt or decrypt one block More...
void | ProcessBlock (byte *inoutBlock) const
| encrypt or decrypt one block in place
virtual unsigned int | BlockSize () const =0
| block size of the cipher in bytes
virtual bool | IsPermutation () const
| returns true if this is a permutation (i.e. there is an inverse transformation)
virtual bool | IsForwardTransformation () const =0
| returns true if this is an encryption object
virtual unsigned int | OptimalNumberOfParallelBlocks () const
| return number of blocks that can be processed in parallel, for bit-slicing implementations
virtual size_t | AdvancedProcessBlocks (const byte *inBlocks, const byte *xorBlocks, byte *outBlocks, size_t length, word32 flags) const
| encrypt and xor blocks according to flags (see FlagsForAdvancedProcessBlocks) More...
CipherDir | GetCipherDirection () const
virtual std::string | AlgorithmName () const
| returns name of this algorithm, not universally implemented yet
virtual Clonable * | Clone () const
| this is not implemented by most classes yet

## Public Attributes

enum BlockTransformation:: { ... } | FlagsForAdvancedProcessBlocks

## Protected Member Functions

virtual bool | Strengthened () const =0
const Algorithm & | GetAlgorithm () const
void | ThrowIfInvalidKeyLength (size_t length)
void | ThrowIfResynchronizable ()
void | ThrowIfInvalidIV (const byte *iv)
size_t | ThrowIfInvalidIVLength (int size)
const byte * | GetIVAndThrowIfInvalid (const NameValuePairs &params, size_t &size)
void | AssertValidKeyLength (size_t length) const

## Protected Attributes

SecByteBlock | keySchedule

## Static Protected Attributes

static const byte | exp_tab [256]
static const byte | log_tab [256]

## Detailed Description

Definition at line 30 of file safer.h.

## Member Function Documentation

virtual void SimpleKeyingInterface::SetKey | ( | const byte * | key,
|  | size_t | length,
|  | const NameValuePairs & | params = `g_nullNameValuePairs`
| ) |  |

virtual inherited

set or reset the key of this object

Parameters

  params | is used to specify Rounds, BlockSize, etc.

Reimplemented in ECB_OneWay, and AuthenticatedSymmetricCipherBase.

bool SimpleKeyingInterface::IsResynchronizable | ( |  | ) | const

inline inherited

returns whether this object can be resynchronized (i.e. supports initialization vectors)

If this function returns true, and no IV is passed to SetKey() and CanUseStructuredIVs()==true, an IV of all 0's will be assumed.

Definition at line 385 of file cryptlib.h.

Referenced by CipherModeBase::OptimalDataAlignment().

virtual void SimpleKeyingInterface::GetNextIV | ( | RandomNumberGenerator & | rng,
|  | byte * | IV
| ) |  |

virtual inherited

get a secure IV for the next message

This method should be called after you finish encrypting one message and are ready to start the next one. After calling it, you must call SetKey() or Resynchronize() before using this object again. This method is not implemented on decryption objects.

Reimplemented in VMAC_Base.

void BlockTransformation::ProcessBlock | ( | const byte * | inBlock,
|  | byte * | outBlock
| ) |  | const

inline inherited

encrypt or decrypt one block

Precondition
  size of inBlock and outBlock == BlockSize()

Definition at line 436 of file cryptlib.h.

virtual size_t BlockTransformation::AdvancedProcessBlocks | ( | const byte * | inBlocks,
|  | const byte * | xorBlocks,
|  | byte * | outBlocks,
|  | size_t | length,
|  | word32 | flags
| ) |  | const

virtual inherited

encrypt and xor blocks according to flags (see FlagsForAdvancedProcessBlocks)

/note If BT_InBlockIsCounter is set, last byte of inBlocks may be modified.

The documentation for this class was generated from the following file:

- safer.h